//+---------------------------------------------------------------------+
//|                                                 Basketbull_v6.03    |
//|                                  Vadim Zakharov aka Yuritch, 2010   |
//|                 Code Optimization Nikolaev Victor aka Vinin, 2009   |
//+---------------------------------------------------------------------+

#include <OrderReliable_V2_0_0.mqh>
#include <WinUser32.mqh>
#define WM_COMMAND  0x0111

#import "user32.dll"
   int GetAncestor(int hWnd, int gaFlags);
   int PostMessageA(int hWnd,int Msg,int wParam,int lParam);
#import
#property show_inputs

extern int  basket   =  8;
extern string PAIR_SELECTION = "DEFAULT";

extern string _long_basket= "===== Pairs Long =====";
extern string long_basket1= "GBPUSD";
double long_price1= 0;
extern string long_basket2= "EURGBP";
double long_price2= 0;
extern string long_basket3= "GBPJPY";
double long_price3= 0;
extern string long_basket4= "CADJPY";
double long_price4= 0;
extern string long_basket5= "NZDUSD";
double long_price5= 0;
extern string long_basket6= "AUDJPY";
double long_price6= 0;
extern string long_basket7= "EURJPY";
double long_price7= 0;

extern string _short_basket= "===== Pairs Short =====";
extern string short_basket1= "EURUSD";
double short_price1= 0;
extern string short_basket2= "USDJPY";
double short_price2= 0;
extern string short_basket3= "AUDUSD";
double short_price3= 0;
extern string short_basket4= "NZDJPY";
double short_price4= 0;
extern string short_basket5= "GBPCHF";
double short_price5= 0;
extern string short_basket6= "CHFJPY";
double short_price6= 0;
extern string short_basket7= "EURCHF";
double short_price7= 0;

extern string  SIGNAL_INDICATORS = "========================"; 
extern bool    alert             = false;    // Beeps Adviser
extern bool    orest_alert       = false;    // Beeps miniOrest: All couples field
extern bool    anchor_alert      = false;    // Beeps anchor pair
extern string  anchor_pair       = "GBPJPY"; // Anchor pair
extern bool    debug             = true;     // debug output
extern string  DTOsc_param       = "===== Options DTOsc =====";
extern int     rsi_per           = 13;
extern int     K                 = 8;
extern int     D                 = 3;
extern int     S                 = 5;
extern string  Values_DTOsc      = "Values overbought / oversold";
extern int     dto_overb         = 80;       // above this limit do not buy
extern int     dto_overs         = 20;       // below this limit do not sell
extern string  RVI_param         = "===== Options RVI =====";
extern int     rvi_per           = 7;
extern string  sar_param         = "===== Options Parabolic =====";
extern double  sar_step          = 0.08;
extern double  sar_max           = 0.8;
extern string  delay_com         = "===== time you restart the timer, ms.=====";
extern int     delay             = 1000;      //====== Time (ms) restart adviser in timer mode
int            mode_font_size    = 12;

extern string  STRATEGY_PARAMETERS = "========================";
extern bool    timer             = true;    // Conversion Timer (true) or ticks (false)
extern bool    can_trade         = false;    // Allow trading immediately after launch? 
extern string  pause_after_close = "pause after the closing of positions";                                          
extern bool    timeout           = true;     // filters in after the close adviser awaits a new bar or a coup Cart 
extern string  initialization    = "Initialization";
extern bool    coi               = false;    // clear the global variables at initialization / deinitialisation?                                        
extern double  pips_filter       = 100;     // Virtual Profit baskets for open positions 
extern string  filter            = "filter";
extern bool    fibo_pf           = true;    // install a filter on the first level of FIBO, if it was preloaded pips_filter 
extern string  advisor_indic     = "adviser and indicators";
extern int     tf                = 1440;       // timeframe in which an advisor and built-in indicators 
extern string  in_minutes        = "in minutes for the re-discovery";
extern int     go_tf             = 1;        // Delay (minutes) verify the conditions of the opening mode AUTOMATIC                                          
extern string  true_parabolic    = "true-Parabolic, false-discovery bar";
extern bool    parabolic         = false;
extern string  zero_point_txt    = "true-to look_back bar back, false-on zero_point";
extern bool    intraday          = false;     // true - Intraday sell, counting from the current bar minus look_back 
                                             // False - count from the bar, designated or computed below zero_point 
extern int      look_back        = 1;        // Calculate relative to the n-th bar                                          
extern string   date_format      = "format yyyy.mm.dd HH:mm";                                          
extern datetime zero_point       = D'2010.01.01 00:00';
extern string   shift_point      = "shift point of reference";
extern bool     move_zp          = true;     // When move_zp = true "moving" reference point                                             
extern double   Lot              = 0.01;
extern int      min_lot_mtp      =1; // factor for micro to calculate the deviation of the basket.
extern string   fixed_lots       = "if = 0 fixed lot";
extern double   Maximum_Risk     = 0;
extern string   pips_4mark       = "pip, for a 4-mark";
extern double   sl               = 10; // stoploss distance from the current price, input-to 4-sign quotations
extern int      Magic            = 333;
extern string   all_basket       = "false-all basket, true-mark and slot";
extern bool     open_right_only  = false;
extern int      slippage         = 30;       // Allowable slippage rates when opening / closing

extern string  STOP_PARAMETERS = "========================"; 
extern string  drawdown_parms    = "drawdown in percentage for the protection of the deposit";
extern double  Stop              = 100;       // when a drawdown in Stop% positions are closed
extern string  one_in_four       = "Only one in four!";
extern bool    auto_tral         = false;     // Automatic choice of tracer trawl 
extern bool    wpr_tral          = false;    // Run trawl Indicators
extern bool    dto_tral          = false;    // In the parameters we choose one type,
extern bool    rsi_tral          = false;    // kotroy Bodo enabled by default.
extern string  one_of_two        = "Only one of the two!";
extern bool    preset_trail      = false;     // Thrall in currency depot / depot percentage
extern bool    atr_tral          = false;    // Full trawl for ATR    
bool           equity_trail      = false;    // Allow trawl (includes a choice of type trawl in a window or a machine)
extern string  just_profit       = "just profit?";
extern bool    only_profit       = false;    // Tralee only profit? (For the indicator trawls) 
extern string  curr_or_perc      = "start/step in the currency, if 0 - percentage";
extern double  start_trail_val   = 0;  
extern double  trail_val         = 0;        // To use a trawl as TakeProfit set the minimum value> 0 
extern string  proc_trail        = "start/step as a percentage of the deposit";
extern double  start_trail       = 10;
extern double  trail             = 1;        // To use a trawl as TakeProfit set minimum value> 0 
extern string  trail_atr         = "to correct trail for ATR";
extern double  atr_mtp           = 1;        // Coefficient Correction Start / Step trawl for ATR 
extern bool    mtp               = true;     // If true, then adjust for ATR: start_trail * mtp * atr_val 
extern string  meet_subsidence   = "meet subsidence? (false - no)"; // When subsidence StopLoss shifts toward subsidence.  
extern bool    update_stop       = false;    // Move the stop to meet the drawdown = true 
double         starting_target;
extern string  reverse_buckets   = "in reverse baskets, false-ignore";
extern  bool   exit_on_reverse   = false;

extern string TRADING_TIME_PARMAMETERS= "in end_hourm = start_houre - all day";
bool           time_restriction  = false;
extern string  sell_or_rest      = "sell = true, rest = false";
extern bool    friday            = true;
extern string  Trade_Hours       = "am / pm session, 24H";
extern string  Trade_Hours_M     = "Morning Session 0-12"; // If the end of the morning session = start the evening - we sell the whole day. 
extern  int    start_hourm       = 0;
extern  int    end_hourm         = 12;
extern string  Trade_Hours_E     = "Evening Session 12-24";
extern  int    start_houre       = 12;
extern  int    end_houre         = 24;

//======= INTERNAL VARIABLES ADVISER 
string   Pairs[];
string   buy_comm =  "Buy_";
string   sell_comm=  "Sell_";
datetime open_time;                 // Open the first position of advisor or manually from the advisor
double   BuyTradeProfit;
double   SellTradeProfit;
double   pips_trigger;              // The computed value of the filter - a function of lot size 
double   wpr_val, rsi_val, atr_val, delta_rsi, rvi_val, dtom,dtom_sig,delta_dtom,atr;
double   i_pcnt;
double   pcnt,pcntd,target_dollars;
double   start_trail_temp;          // store the preset start_trail Recovery 


int      iBuyTradeProfit;
int      iSellTradeProfit;
int      num_pair;                  //Number of pairs to trade, use to calculate the size of the lot 
int      CountSymbol;
int      lot_mtp=1;                 // multiplier for manual correction of the unit size 
int      long_step,short_step;      // counters open baskets 

color    timercolor=Lime;

bool     first_run      =  false;   // Delay activity adviser for the prevention of delayed entry 
bool     lock           =  false;   // reserved for multipozitsiyu ... 

bool     zp_short       =  true;    // Correction of a reference point in the downward movement 
bool     zp_long        =  true;    // Correction of a reference point in an upward movement 
bool     longs_allowed=true,short_alert=true,long_alert=true,jump_alert=true,trail_alert=true;
bool     shorts_allowed=true;

string   long_basket[7];
string   short_basket[7];
double   long_price[7];
double   short_price[7];

double   LB[7];                  //
double   SB[7];                  //
double   LB_now[7];              //
double   SB_now[7];              //
double   LB_pips[7];             //
double   SB_pips[7];             //
int      lb[7], sb[7];           //
   int   Basket[32][2];
   double   BuySumm[15][3];
   double   SellSumm[15][3];
   string   BasketNameLong[15];
   string   BasketNameShort[15];
   int basket_long,basket_short;
   
   string PairsDisplay[];   
   color  PairsColor[];              
   double PLArray[];

double   highest_long_pips, highest_short_pips,long_pips, short_pips,total_pips,highest_total_pips;
string   signal,trail3,trail2,pcnt2,pcnt3,target3,target2;
int      red,green,buys,sells;

bool     close_l= false,close_s= false,close_all= false,open_buys= false,open_sells= false;
int      slot=0, anchor=0; //     red_alert= true, green_alert= true;
        
string   stat= "wait";



//+------------------------------------------------------------------+
//|   EA INITIALIZATION                           
//+------------------------------------------------------------------+

int init() {

      clear();
   Object_field("timer", "START ADVISER", 120, 280, 10, "Calibri Bold", timercolor, CLR_NONE);
   if (coi) GlobalVariablesDeleteAll(); 
   Comment("");
   
    switch (basket)
               {
                 case 2 :
                  long_basket1= "";
                  long_basket2= "";
                  long_basket3= "";
                  long_basket4= "";
                  long_basket5= "";
                  long_basket6= "";
                  long_basket7= "";

                  short_basket1= "";
                  short_basket2= "";
                  short_basket3= "";
                  short_basket4= "";
                  short_basket5= "";
                  short_basket6= "";
                  short_basket7= "";
                  break;
                 case 4 :
                  long_basket1= "GBPUSD";
                  long_basket2= "EURJPY";
                  long_basket3= "";
                  long_basket4= "";
                  long_basket5= "";
                  long_basket6= "";
                  long_basket7= "";

                  short_basket1= "EURUSD";
                  short_basket2= "GBPJPY";
                  short_basket3= "";
                  short_basket4= "";
                  short_basket5= "";
                  short_basket6= "";
                  short_basket7= "";
                  break;
                 case 6 :
                  long_basket1= "";
                  long_basket2= "";
                  long_basket3= "";
                  long_basket4= "";
                  long_basket5= "";
                  long_basket6= "";
                  long_basket7= "";

                  short_basket1= "";
                  short_basket2= "";
                  short_basket3= "";
                  short_basket4= "";
                  short_basket5= "";
                  short_basket6= "";
                  short_basket7= "";
                  break;                                                     
                 case 8 :
                  long_basket1= "GBPUSD";
                  long_basket2= "EURJPY";
                  long_basket3= "AUDUSD";
                  long_basket4= "NZDJPY";
                  long_basket5= "";
                  long_basket6= "";
                  long_basket7= "";

                  short_basket1= "EURUSD";
                  short_basket2= "GBPJPY";
                  short_basket3= "NZDUSD";
                  short_basket4= "AUDJPY";
                  short_basket5= "";
                  short_basket6= "";
                  short_basket7= "";
                  break;
                 case 10 :
                  long_basket1= "";
                  long_basket2= "";
                  long_basket3= "";
                  long_basket4= "";
                  long_basket5= "";
                  long_basket6= "";
                  long_basket7= "";

                  short_basket1= "";
                  short_basket2= "";
                  short_basket3= "";
                  short_basket4= "";
                  short_basket5= "";
                  short_basket6= "";
                  short_basket7= "";
                  break;
                 case 12 :
                  long_basket1= "";
                  long_basket2= "";
                  long_basket3= "";
                  long_basket4= "";
                  long_basket5= "";
                  long_basket6= "";
                  long_basket7= "";

                  short_basket1= "";
                  short_basket2= "";
                  short_basket3= "";
                  short_basket4= "";
                  short_basket5= "";
                  short_basket6= "";
                  short_basket7= "";
                  break;                                      
                 case 14 :
                  long_basket1= "GBPUSD";
                  long_basket2= "EURGBP";
                  long_basket3= "GBPJPY";
                  long_basket4= "CADJPY";
                  long_basket5= "NZDUSD";
                  long_basket6= "AUDJPY";
                  long_basket7= "EURJPY";

                  short_basket1= "EURUSD";
                  short_basket2= "USDJPY";
                  short_basket3= "AUDUSD";
                  short_basket4= "NZDJPY";
                  short_basket5= "GBPCHF";
                  short_basket6= "CHFJPY";
                  short_basket7= "EURCHF";
                  break;
                 default:
                  break;
               }
               
   InitGlobalValue();

   int i, CountLong=0, CountShort=0;
   CountLong  =AddValue(long_basket,  long_price,  long_basket1,  long_price1, CountLong );
   CountLong  =AddValue(long_basket,  long_price,  long_basket2,  long_price2, CountLong );
   CountLong  =AddValue(long_basket,  long_price,  long_basket3,  long_price3, CountLong );
   CountLong  =AddValue(long_basket,  long_price,  long_basket4,  long_price4, CountLong );
   CountLong  =AddValue(long_basket,  long_price,  long_basket5,  long_price5, CountLong );
   CountLong  =AddValue(long_basket,  long_price,  long_basket6,  long_price6, CountLong );
   CountLong  =AddValue(long_basket,  long_price,  long_basket7,  long_price7, CountLong );
   
   CountShort =AddValue(short_basket, short_price, short_basket1, short_price1, CountShort);
   CountShort =AddValue(short_basket, short_price, short_basket2, short_price2, CountShort);
   CountShort =AddValue(short_basket, short_price, short_basket3, short_price3, CountShort);
   CountShort =AddValue(short_basket, short_price, short_basket4, short_price4, CountShort);
   CountShort =AddValue(short_basket, short_price, short_basket5, short_price5, CountShort);
   CountShort =AddValue(short_basket, short_price, short_basket6, short_price6, CountShort);
   CountShort =AddValue(short_basket, short_price, short_basket7, short_price7, CountShort);

   CountSymbol=MathMin(CountLong, CountShort);
   if (CountLong != CountShort) 
   {
   MessageBox("The number of pairs of slots should be the same!","error",MB_OK|MB_ICONHAND);
   return(0);
   }
   ArrayResize(long_basket, CountSymbol);
   ArrayResize(long_price,  CountSymbol);
   ArrayResize(short_basket,CountSymbol);
   ArrayResize(short_price, CountSymbol);
   
   num_pair=CountSymbol*2;
         
   ArrayResize(Pairs,num_pair);
   ArrayResize(PairsDisplay,num_pair);
   ArrayResize(PairsColor,num_pair);
   ArrayResize(PLArray,num_pair);   
   
   GlobalVariableSet("num_pair",num_pair);
   
   for (i=0;i<CountSymbol;i++) {
      Pairs[i            ] = long_basket[i];
      Pairs[i+CountSymbol] = short_basket[i];
   }

   if (timeout) first_run   = true;
   if    (parabolic) look_back = 0;       // Parabolic believe only the current bar 
   if    (start_trail_val >0)   start_trail=(start_trail_val/AccountBalance())*100;
   if    (trail_val >0)         trail = (trail_val/AccountBalance())*100;
   if (MarketInfo("EURUSD",MODE_DIGITS)==5 )// Cater for 5 d.p. quotes
   {
      sl=sl*10;
      if (parabolic==true) pips_filter=pips_filter*10; 
      else pips_filter=pips_filter/(0.1/MarketInfo("EURUSD",MODE_MINLOT));
   } 
   if (intraday == false && parabolic == false)  {
      ArrayInitialize(long_price,0);
      ArrayInitialize(short_price,0);

   }
   
   if (GlobalVariableCheck("long_step") == true) long_step=GlobalVariableGet("long_step");
   if (GlobalVariableCheck("short_step") == true) short_step=GlobalVariableGet("short_step"); 
   
   ArrayInitialize(BuySumm,0);
   ArrayInitialize(SellSumm,0);
 
   starting_target      =  -Stop;         // Set your Stopout 
   start_trail_temp     =  start_trail;   // Ustanovmi BreakEven 
   orders();
   check_indi();
   checkup();
   run_statistics_longs();  
   run_statistics_shorts();

   check_pcnt(); 
   check_signal();
//   highest_long_pips    =  0;
//   highest_short_pips   =  0;
   draw_objects();
   draw_orest();


   return;
}

int AddValue(string &abasket[], double &aprice[], string basket, double price, int Count) {
   if (basket=="") return(Count);
   abasket[Count]=basket;
   aprice[Count]=price;
   Count++; 
   return(Count);
}

//+------------------------------------------------------------------+
//|   STOP AND CLEAR MT4 WINDOWS                               
//+------------------------------------------------------------------+

int deinit() {
   clear();
   if (coi) GlobalVariablesDeleteAll(); 
   Comment("");
   return(0);
}

//+------------------------------------------------------------------+
//|   START ADVISER                              
//+------------------------------------------------------------------+

int start() {
       if ( !IsDllsAllowed() )
    {
        Alert( "Allow import of dll in the settings!" );
        return;
    }

   if (timer==false) {
      main();
      timer_set();
      return;
   } else {
   while (IsExpertEnabled())    // Pause to change settings Adviser
      {
      WindowRedraw();
      main();
      Sleep(delay); 
      timer_set();
      if  (timer==false) break;
      }
   return;
   }
}

//+------------------------------------------------------------------+
//|  SUBROUTINES                              
//+------------------------------------------------------------------+
void main()
{
double fibo_long=0, fibo_short=0;
orders();

pips_trigger=pips_filter/14*num_pair;

if (fibo_pf)                           // Correction filter FIBO
{
   if (total_pips>0 && short_pips <0) fibo_long=(highest_total_pips*23.6)/100; 
   if (total_pips<0 && long_pips <0) fibo_short=MathAbs(highest_total_pips*23.6)/100;

   if (pips_trigger < fibo_long || pips_trigger < fibo_short)
   {
      if (total_pips >0) pips_trigger=fibo_long;
      if (total_pips <0) pips_trigger=fibo_short;
   }
}    

if (start_trail_val !=0) start_trail=(start_trail_val/AccountBalance())*100;  
if (trail_val !=0) trail= (trail_val/AccountBalance())*100;

if (mtp==true) atr=atr_mtp*atr_val;    // Auto size trawl for ATR
 
if(GlobalVariableCheck("zero_point")==true && move_zp==true) zero_point = GlobalVariableGet("zero_point"); 
if(GlobalVariableCheck("zp_short")==true && zp_short != GlobalVariableGet("zp_short")) zp_short = GlobalVariableGet("zp_short");
if(GlobalVariableCheck("zp_long")==true && zp_long != GlobalVariableGet("zp_long")) zp_long = GlobalVariableGet("zp_long");

if (GlobalVariableGet("long_step") != long_step) GlobalVariableSet("long_step",long_step);
if (GlobalVariableGet("short_step") != short_step) GlobalVariableSet("short_step",short_step);   

checkup();
run_statistics_longs();  
run_statistics_shorts();
check_pcnt();
check_exit();
check_signal();

   total_pips=(long_pips-short_pips);

   if (total_pips>0 && total_pips >= highest_total_pips) // reached the previous peak Shopping 
      {
      
       if (move_zp) zero_point= iTime(Symbol(),tf,0) ; // move the reference point, because possible rebound 
       GlobalVariableSet("zero_point",zero_point);
       highest_total_pips=total_pips;
       GlobalVariableSet("maxtotal",NormalizeDouble(highest_total_pips,0));  // remember the new maximum 
      if (GlobalVariableGet("maxtotal_long") < highest_total_pips) GlobalVariableSet("maxtotal_long",NormalizeDouble(highest_total_pips,0));
      }
   if (total_pips<0 && total_pips<=highest_total_pips) // cart reached a recent low 
      {
       if (move_zp) zero_point= iTime(Symbol(),tf,0) ; // move the reference point, because possible rebound
       GlobalVariableSet("zero_point",zero_point);
       highest_total_pips=total_pips; 
       GlobalVariableSet("maxtotal",NormalizeDouble(highest_total_pips,0)); // remember the new minimum 
       if (GlobalVariableGet("maxtotal_short") > highest_total_pips) GlobalVariableSet("maxtotal_short",NormalizeDouble(highest_total_pips,0));
      } 
      
CalculatePipsProfit();
trail3      =  DoubleToStr(start_trail,2);
trail2      =  DoubleToStr(trail,2);
pcnt2       =  DoubleToStr(pcnt,2);
pcnt3       =  DoubleToStr(pcntd,2);
target3     =  DoubleToStr(target_dollars,2);
target2     =  DoubleToStr(starting_target,2);


if (pcntd<0 && update_stop) starting_target = -i_pcnt;                  // move towards subsidence 
if (pcntd>0 && update_stop && !equity_trail) starting_target = -Stop;   // Drawdown is over, return stop (if not included trawl) 

if(close_l==false&&close_s==false&&close_all==false&&open_buys==false&&open_sells==false) stat="wait";


if ((total_pips > pips_trigger && short_pips  < 0) && zp_long==true)    //  Shopping crossed 0 up 
                                                     
   {
   if (first_run==true) first_run = false;                  // Remove the timeout shopping 
   if (move_zp==true)  zero_point= iTime(Symbol(),tf,0) ;   // Move the starting point for the current bar, if allowed
   GlobalVariableSet("zero_point",zero_point);
   zp_short=true;                                           // displace only if 
   zp_long=false;                                           // again cross 0 down 
   GlobalVariableSet("zp_short",zp_short);
   GlobalVariableSet("zp_long",zp_long);
   }
   
if ((total_pips < pips_trigger*(-1) && long_pips < 0) && zp_short==true) // Shopping crossed 0 down 
                                                      
   {
   if (first_run==true) first_run = false;                  // Remove trading timeout 
   if (move_zp==true) zero_point= iTime(Symbol(),tf,0) ;    // Move the starting point for the current bar, if allowed 
   GlobalVariableSet("zero_point",zero_point);
   zp_short=false;                                          // displace only if
   zp_long=true;                                            // 0 up again will cross 
   GlobalVariableSet("zp_short",zp_short);
   GlobalVariableSet("zp_long",zp_long);
   }
 
if (IsNewBar(go_tf) && !first_run && can_trade)             // Checking the conditions for opening in the MACHINE 
   {
      if (signal=="long" && dtom < dto_overb && delta_dtom >0 && wpr_val < -30 && rvi_val> 0 && rsi_val <65) // Condition for purchases
      {
      t101buy();           
      }
      if (signal=="short" && dtom > dto_overs && delta_dtom <0 && wpr_val > -70 && rvi_val < 0 && rsi_val >35) // Condition for sales
      {
      t101sell();          
      }
   }
       
   draw_objects();
   draw_orest();
   draw_field();
   obj_check();
   view_baskets();
   if (debug) comments();
   
return;
}

//+------------------------------------------------------------------+
//|    CALCULATION OF OPEN POSITIONS                               
//+------------------------------------------------------------------+
void orders() {
   int i,j;
   pcnt =(iBuyTradeProfit+iSellTradeProfit)/ AccountBalance()*100;  //If you believe profit / loss advisor
   pcntd=(iBuyTradeProfit+iSellTradeProfit);
//   pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100; // If you consider the overall profit / loss
//   pcntd =AccountEquity()-AccountBalance() ;
   target_dollars =( (AccountBalance()/100) *starting_target);
   buys=0;
   sells=0;
   open_time=zero_point;
   ArrayInitialize(lb,0);
   ArrayInitialize(sb,0);

   int totalorders = OrdersTotal();

   for(i=totalorders;i>=0;i--) {
      if (!OrderSelect(i, SELECT_BY_POS))          continue;
      if ( OrderMagicNumber() != Magic )           continue;
      if (OrderOpenTime() < open_time)
       {
       open_time=OrderOpenTime();
       }
      if ( OrderType() == OP_SELL)  sells++;
      if ( OrderType() == OP_BUY)   buys++;
      for (j=0;j<CountSymbol;j++) {
         if ( OrderSymbol() == long_basket[j] )  lb[j]++;
         if ( OrderSymbol() == short_basket[j])  sb[j]++;
      }
   }
   GlobalVariableSet("opentime",open_time);
   return;
}

//+------------------------------------------------------------------+
//|    CONVERSION OF INITIAL CONDITIONS                              
//+------------------------------------------------------------------+
void checkup() 
{
   int i;
   if (intraday == false && parabolic == false)    // The starting point - from the opening bars, given in zero_point 
   {
      for (i=0;i<CountSymbol;i++) {
         long_price[i]  = iOpen(long_basket[i], tf,iBarShift(long_basket[i],tf,zero_point,0));
         short_price[i] = iOpen(short_basket[i],tf,iBarShift(short_basket[i],tf,zero_point,0));
      }
   } 
         
   if (parabolic == true)                          // calculation of Parabolic 
    {
      for (i=0;i<CountSymbol;i++) {
         if (long_price[i]==0)  LB[i]= iSAR(long_basket[i], tf,sar_step,sar_max,look_back); else LB[i]=long_price[i];
         if (short_price[i]==0) SB[i]= iSAR(short_basket[i],tf,sar_step,sar_max,look_back); else SB[i]=short_price[i];
      }
   } 
   else                                            // Moving startpoint = closure (look_back) bar from the current 
   {
         for (i=0;i<CountSymbol;i++) {
         if (long_price[i]==0)  LB[i]= iClose(long_basket[i],  tf, look_back); else LB[i]=long_price[i];
         if (short_price[i]==0) SB[i]= iClose(short_basket[i], tf, look_back); else SB[i]=short_price[i];
      }
   }
   return;
}

//+------------------------------------------------------------------+
//|   STATISTICS ON PARAM LONGS                               
//+------------------------------------------------------------------+
void run_statistics_longs() {
   int i;
   int spread[7];
   long_pips =0;
   
   if (parabolic==true) 
   {
      for (i=0;i<CountSymbol;i++) {
         LB_now[i]= MarketInfo(long_basket[i],MODE_ASK);
         spread[i]= MarketInfo(long_basket[i],MODE_SPREAD);
         LB_pips[i] = (LB_now[i]-LB[i])/MarketInfo(long_basket[i],MODE_POINT)-spread[i];
         long_pips +=LB_pips[i];
      }
   } else    {
      for (i=0;i<CountSymbol;i++) {
         LB_now[i]= MarketInfo(long_basket[i],MODE_ASK);
         spread[i]= MarketInfo(long_basket[i],MODE_POINT)*MarketInfo(long_basket[i],MODE_SPREAD);
         LB_pips[i] = (LB_now[i]-LB[i])/MarketInfo(long_basket[i],MODE_POINT)-spread[i];
         LB_pips[i] = LB_pips[i]*MarketInfo(long_basket[i],MODE_TICKVALUE)*MarketInfo(long_basket[i],MODE_MINLOT)*min_lot_mtp;
         long_pips +=LB_pips[i];
      }
   }
   if (long_pips>highest_long_pips)  highest_long_pips=long_pips;
     
   if (highest_long_pips>GlobalVariableGet("maxlong")) 
   {
    GlobalVariableSet("maxlong",NormalizeDouble(highest_long_pips,0));
   }
   return;
}

//+------------------------------------------------------------------+
//|     STATISTICS ON PARAM SHORTS                                
//+------------------------------------------------------------------+
void run_statistics_shorts(){
   int i;
   int spread[7];
   short_pips =0;

   if (parabolic==true) 
   {
      for (i=0;i<CountSymbol;i++) {
         SB_now[i]= MarketInfo(short_basket[i],MODE_BID);
         spread[i]= MarketInfo(short_basket[i],MODE_SPREAD);
         SB_pips[i] = (SB[i]-SB_now[i])/MarketInfo(short_basket[i],MODE_POINT)-spread[i];
         short_pips += SB_pips[i];
      }
   } else {   
      for (i=0;i<CountSymbol;i++) {
         SB_now[i]= MarketInfo(short_basket[i],MODE_BID);
         spread[i]= MarketInfo(short_basket[i],MODE_POINT)*MarketInfo(short_basket[i],MODE_SPREAD);
         SB_pips[i] = (SB[i]-SB_now[i])/MarketInfo(short_basket[i],MODE_POINT)-spread[i];
         SB_pips[i] = SB_pips[i]*MarketInfo(short_basket[i],MODE_TICKVALUE)*MarketInfo(long_basket[i],MODE_MINLOT)*min_lot_mtp;
         short_pips += SB_pips[i];
      }
   }
   
   if (short_pips>highest_short_pips)    highest_short_pips=short_pips;
  
   if (highest_short_pips>GlobalVariableGet("maxshort"))
   { 
      GlobalVariableSet("maxshort",NormalizeDouble(highest_short_pips,0));
   }
   return;
}

//+------------------------------------------------------------------+
//|   Trading signals, Lock, Counters, Sessional LIMITATION                                
//+------------------------------------------------------------------+
void check_signal()
{
   signal = "Ranging";
   
   if (first_run && !close_all && (buys !=0 || sells !=0)) first_run=false;   // opened his hands, remove the timeout 
   
   if (first_run && IsNewBar(tf)) 
      {
      first_run=false;           // The new bar, remove the timeout on trade.
      if (move_zp) reset_zp();   // Move the starting point for the current bar, if allowed
      run_statistics_shorts();   // convert it to reject new zero_point
      run_statistics_longs();
      return;
      }
   if (friday || TimeDayOfWeek(TimeCurrent())!=5)
      {
      if (total_pips>0 && total_pips>pips_trigger && first_run == false) {signal = "long";}              // buy signal on the breakdown of the filter 
      if (total_pips <0 && total_pips<(pips_trigger * (-1)) && first_run == false) {signal = "short";}   // Signal sales breakdown filter 
      }
   if ( buys==0 && sells==0 )   {
      longs_allowed=true;
      shorts_allowed=true;
      starting_target=-Stop;
      for (int i=0; i<=MathMax(long_step,short_step);i++)
         {
         if (ObjectFind(buy_comm+i)==0) ObjectDelete(buy_comm+i);
         if (ObjectFind(sell_comm+i)==0) ObjectDelete(sell_comm+i);
         }      
      long_step=0;
      short_step=0;

      if (GlobalVariableGet("opentime") != zero_point) GlobalVariableSet("opentime",zero_point);
   }

   if (long_pips<=0 ){highest_long_pips=0;}
   if (short_pips<=0){highest_short_pips=0;}

   if (Hour()>=start_hourm && Hour()<end_hourm || Hour()>=start_houre && Hour()<end_houre)time_restriction=true; else time_restriction=false;
   if (time_restriction&&close_l==false&&close_s==false&&close_all==false&&open_buys==false&&open_sells==false&&longs_allowed&&signal=="long")
   {
      shorts_allowed=true;
   }

   if (time_restriction&&close_l==false&&close_s==false&&close_all==false&&open_buys==false&&open_sells==false&&shorts_allowed&&signal=="short")
   {
      longs_allowed=true;
   }
   if (green >= CountSymbol && red==0 && slot==1 && orest_alert)  // Alert Orestes
   {
      Alert("Mini-Orestes: a pair of slots, "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES));
      slot=-1;
   }
      if (red>=CountSymbol && green==0 && slot==-1 && orest_alert)
   {
      Alert("Mini-Orestes: a pair of slots, "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES));
      slot=1;      
   }
   return;   
}
//+------------------------------------------------------------------+
//|     TEST CONDITIONS TRAILING AND CLOSING                                
//+------------------------------------------------------------------+
void check_exit() {
   check_indi();
   if (preset_trail || atr_tral || auto_tral || wpr_tral || dto_tral || rsi_tral) equity_trail = true;
   else equity_trail = false;
   
   if (only_profit)                       // Trailing only profit
   {
   if (rsi_tral)                 // Start a trail for RSI
   {
      if (((rsi_val>=65 && buys !=0) ) || ((rsi_val<=35 &&sells !=0)) && pcntd>0 && pcnt-starting_target > trail)
      {
      starting_target=pcnt-trail;
      }
   }
   if (wpr_tral)                 // Start a trail for WPR
   {  
      
      if (((wpr_val>=-20 && buys !=0)) || ((wpr_val<=-80 &&sells !=0)) && pcntd>0 && pcnt-starting_target > trail)
      {
      starting_target=pcnt-trail;
      }
   }
   if (dto_tral)                 // Start a trail for DTOsc
   {
      if (((delta_dtom <0  && buys !=0) || (delta_dtom > 0 && sells !=0)) && pcntd>0 && pcnt-starting_target > trail)
      {
      starting_target=pcnt-trail;
      }
   }
   } else {                               // Trailing profit and loss - on signals an overbought / oversold 
      if (rsi_tral)              // Start a trail for RSI
   {
      if (((rsi_val>=65 && buys !=0) ) || ((rsi_val<=35 &&sells !=0)) && pcnt-starting_target > trail)
      {
      starting_target=pcnt-trail;
      }
   }
   if (wpr_tral) // Start a trail for WPR
   {  
      
      if (((wpr_val>=-20 && buys !=0)) || ((wpr_val<=-80 &&sells !=0)) && pcnt-starting_target > trail)
      {
          starting_target=pcnt-trail;
      }
   }
   if (dto_tral)                 // Start a trail for DTOsc
   {
      
      if (((delta_dtom <0  && buys !=0) || (delta_dtom > 0 && sells !=0)) && pcnt-starting_target > trail)
      {
         starting_target=pcnt-trail;
      }
    }
    } 
     
   if (atr_tral && pcntd >0 && pcnt > start_trail*atr && pcnt-starting_target > trail*atr ) // Current Taiko / stop on ATR 
   {
         starting_target=pcnt-trail*atr;
   }     
   if (preset_trail && pcnt >= start_trail && pcnt-starting_target > trail ) // Trail currency deposit 
      {
       starting_target=pcnt-trail;
      }

   if (pcnt<=starting_target ) 
   {
      close_all=true;                        // tripped stop - close all 
      if (move_zp) reset_zp();               // Moves zero_point at the time of closing 
      highest_total_pips=0;
      GlobalVariableSet("maxtotal",0);       // Resets extreme deviation Cart 
      if (timeout) first_run=true;           // Set the trade timeout, if allowed 
   }
   
if (exit_on_reverse)                // Action if the reverse Cart 
   {    
   if (buys !=0 && long_pips <=0) 
   {
   close_longs();                   // Turn baskets - closing purchase 
   if (move_zp) reset_zp();         // Moves zero_point at the time of closing 
      highest_total_pips=0;
      GlobalVariableSet("maxtotal",0);
    }
   if (sells !=0 && short_pips <=0) 
   {
   close_shorts();                  // Turn baskets - closing sales
   if (move_zp) reset_zp();         // Moves zero_point at the time of closing 
      highest_total_pips=0;
      GlobalVariableSet("maxtotal",0);
    }
    }

if(close_l) {longs_allowed=false;close_longs();}
if(close_s) {shorts_allowed=false;close_shorts();}
if(close_all&&buys>0){longs_allowed=false; close();}
if(close_all&&sells>0){longs_allowed=false; close();}
if(close_l&&buys==0) close_l=false;
if(close_s&&sells==0) close_s=false;
if(close_all&&buys==0&&sells==0) close_all=false;

   return;
}

//+------------------------------------------------------------------+
//|  DEBUG OUTPUT                               
//+------------------------------------------------------------------+
void comments(){
   Object_field("Debug",
   " DRVI= "+DoubleToStr(rvi_val,1)
   +" DDTO= "+DoubleToStr(delta_dtom,1)
   +" Filter="+DoubleToStr(pips_trigger,0)
   +" RSI="+DoubleToStr(rsi_val,1)
   +" WPR="+DoubleToStr(wpr_val,1),
   5, 480, 10, "Calibri", White, Yellow);
   return;
}

//+------------------------------------------------------------------+
//|    LOT SIZE CALCULATIONS                               
//+------------------------------------------------------------------+
double LotsOptimized(string symbol)
{
double minimum_lots=MarketInfo(symbol,MODE_MINLOT);
double max_lots=MarketInfo(symbol,MODE_MAXLOT);
double lot=Lot;   

     if (minimum_lots==0.001){ lot=NormalizeDouble(AccountBalance()/CountSymbol*2*Maximum_Risk/100000,3);}
     if (minimum_lots==0.01){ lot=NormalizeDouble(AccountBalance()/CountSymbol*2*Maximum_Risk/1000000,2);}
     if (minimum_lots==0.1){ lot=NormalizeDouble(AccountBalance()/CountSymbol*2*Maximum_Risk/10000000,1);}  
     if (minimum_lots==1){ lot=NormalizeDouble(AccountBalance()/CountSymbol*2*Maximum_Risk/100000000,0);}
     
     if (lot<=Lot){lot  = Lot;}      // Minimum lot - no less than set in the options Adviser
     if (lot<=minimum_lots){lot  = minimum_lots;}
     if (lot>=max_lots/CountSymbol*2){lot  = max_lots/CountSymbol*2;}
     if (Maximum_Risk==0) {return(lot*lot_mtp);}
      else {return (lot);}
   
}

//+------------------------------------------------------------------+
//|     CONCLUSION MINIOREST                               
//+------------------------------------------------------------------+
void draw_orest()
{
   green=0;red=0;                                                                                  
   string text;
   color CL;
   string Srift;
   int i;
   for (i=0;i<CountSymbol;i++) {
      PLArray[i            ]=LB_pips[i]; 
      PLArray[i+CountSymbol]=SB_pips[i]; 
   }      

   ArraySort(PLArray,WHOLE_ARRAY,0,MODE_DESCEND);

   
   for(i=0;i<2*CountSymbol;i++) { 
      for (int j=0;j<CountSymbol;j++) {
         if(LB_pips[j]==PLArray[i]) {
            PairsDisplay[i] = ""+long_basket[j]+"";
            if (lb[j]>0) 
               PairsColor[i] = Lime;
            else
               PairsColor[i] = Green; 
            if (LB_pips[j]>0)     green++;
         }
      }
      for (j=0;j<CountSymbol;j++) {
         if(SB_pips[j]==PLArray[i]) {
            PairsDisplay[i] = ""+short_basket[j]+"";
            if (sb[j]>0) PairsColor[i] = Orange;
            else PairsColor[i] = Red; 
            if (SB_pips[j]>0)     red++;
         }
      }

    }
    if (PairsDisplay[0]== anchor_pair && anchor_alert && anchor >=0)
         {
            Alert(anchor_pair+" anchored!");
            anchor=-1;
          }
    if (PairsDisplay[2*CountSymbol-1]== anchor_pair && anchor_alert && anchor <=0)
         {
            Alert(anchor_pair+" anchored!");
            anchor=1;
          }
     if (PairsDisplay[0]!= anchor_pair && PairsDisplay[2*CountSymbol-1] != anchor_pair && anchor !=0)
         {
           Alert(anchor_pair+" weighed anchor!");
           anchor=0;
         }           
   for (i=0;i<2*CountSymbol;i++)
      if (i <CountSymbol) Object_field(""+i+1, PairsDisplay[i]+"= "+DoubleToStr(PLArray[i],0), 10,  40+i*20, 10, "Consolas Bold", Red, PairsColor[i]);
      else Object_field(""+i+1, PairsDisplay[i]+"= "+DoubleToStr(PLArray[i],0), 10,  40+(i+1)*20, 10, "Consolas Bold", Red, PairsColor[i]);
      
} // draw_orest

//+------------------------------------------------------------------+
//|     OUTPUT OBJECTS                               
//+------------------------------------------------------------------+
void draw_objects() {
   int i;
   color CL;
   string text;
   
   Object_field("banner1", "",  0,   20, 10, "Calibri", CLR_NONE, Yellow);
   Object_field("banner12", "",  520,   40, 10, "Calibri", CLR_NONE, Yellow);
   Object_field("banner10", "multiplier lot",  0,   440, 10, "Calibri", CLR_NONE, Yellow);
   Object_field("banner8", "",  110, 130, 10, "Calibri", CLR_NONE, Yellow);
   Object_field("banner9", "",  110, 215, 10, "Calibri", CLR_NONE, Yellow);
   Object_field("banner", "", 120,   30, 10, "Calibri", CLR_NONE, Yellow,270);

   text=">MANUAL, TF="+tf+" Lots="+DoubleToStr(LotsOptimized("EURUSD"),2);
   CL=White;
   if (can_trade) {
      text=">Automatic, TF="+tf+" Lots="+DoubleToStr(LotsOptimized("EURUSD"),2);
      CL=Lime;
   }
      Object_field("auto", text, 350,   5, 10, "Calibri Bold", CLR_NONE, CL);
      
   if (can_trade==false)
   {  
      text="Analyze data";
      CL=White;
      
      if (first_run==true && (buys+sells)==0) 
      {
         text="SHOPPING Timeout";
         CL=Gold;
      }
      else
      {
      if (signal == "Ranging") {
         jump_alert=true;
         trail_alert=true;
         text="MOVEMENT WITHIN THE FILTER";
         CL=Gold;
      }
      }
      if ((buys !=0 && signal=="long") || (sells !=0 && signal=="short")) {
         if ((long_pips>pips_trigger) || (short_pips>pips_trigger)) text="CONTROLS POSITION";
         CL=Lime;
      }      
      if (buys==0 && signal=="long" && dtom>dto_overb) { text="DANGER TO BUY: DTO>"+dto_overb; CL=Orange;}
      if (sells==0 && signal=="short" && dtom <dto_overs){ text="SELL DANGER: DTO<"+dto_overs; CL=Orange;}
      
      if (buys==0 && signal=="long" && rsi_val>65) { text="SHOPPING overbought!"; CL=Red;}
      if (sells==0 && signal=="short" && rsi_val<35) { text="SHOPPING Resell!"; CL=Red;}
          
      if ((pcnt>AccountMargin() || pcnt>=atr_val) && equity_trail==false) {
         text="RECOMMEND Trail";
         CL=White;
         if (alert&&trail_alert)PlaySound("alert.wav");
         trail_alert=false;
      }
      if (((highest_short_pips-short_pips)>pips_trigger&&sells !=0 && pcntd<0) 
      ||((highest_long_pips-long_pips)>pips_trigger&&buys !=0 && pcntd<0)) {
         text="BE CAREFUL, subsidence!";
         CL=Red;
         if (alert&&jump_alert)PlaySound("alert.wav");
         jump_alert=false;
      }
      if (total_pips > pips_trigger && dtom < dto_overb && delta_dtom >0 && wpr_val <-20 && buys==0) {
         text="short sell";
         CL=DeepSkyBlue;
         if (alert&&long_alert)PlaySound("alert.wav");
         long_alert=false;
         short_alert=true;
      }
      if (signal=="long" && dtom < dto_overb && delta_dtom >0 && wpr_val < -20 && rvi_val> 0 && rsi_val <65 && buys==0) {
         text="RECOMMEND BUYING";
         CL=DeepSkyBlue;
         if (alert&&long_alert)PlaySound("alert.wav");
         long_alert=false;
         short_alert=true;
      }
      if (total_pips < pips_trigger*(-1) && dtom > dto_overs && delta_dtom < 0 && wpr_val >-80 && sells==0) {
         text="Short Sale";
         CL=Orange;
         if (alert&&short_alert)PlaySound("alert.wav");
         short_alert=false;
         long_alert=true;
      }
      if (signal=="short" && dtom > dto_overs && delta_dtom <0 && wpr_val > -80 && rvi_val < 0 && rsi_val >35 && sells==0) {
         text="RECOMMEND SALES";
         CL=Orange;
         if (alert&&short_alert)PlaySound("alert.wav");
         short_alert=false;
         long_alert=true;
      }
      if (friday==false && TimeDayOfWeek(TimeCurrent())==5) {
         text="Friday, relax!";
         CL=Lime;
      }
   
   } else   {
      text="TENDER MACHINE";
      if (first_run==true)text="SHOPPING Timeout";
      if (friday==false && TimeDayOfWeek(TimeCurrent())==5) {
         text="Friday, relax!";      
      
      }
     CL=Gold; 
   }
   Object_field("sig", text, 120,  255, 10, "Calibri Bold", CL, CL);
 
      
   Object_field("tot", "Calculator", 0,  340, 10, "Calibri", CLR_NONE, Yellow);      

   
   if (buys+sells==0) 
   {
   text="EA Not in market"; 
   CL=White;
   } 
   else
   {
   text="EA Profit: "+pcnt3+"  ("+pcnt2+"%)"; 
   if (pcnt>0)  CL=Lime;
   if (pcnt<0)  CL=Red;
   }

   Object_field("pc", text,  5,  5, 10, "Calibri Bold", CLR_NONE, CL);
//------
   CL=White;
   if (parabolic) {
      text="Calculation of the Parabolic";
   } else {
      if (intraday) {
         text="Count: Closing "+look_back+" bar";
      } else {
         text="Count: Opening "+TimeToStr(zero_point,TIME_DATE|TIME_MINUTES);
      }
   }
   
   if (stat!= "waiting")  CL=Red;
   if (stat== "waiting")  CL=Lime;
   Object_field("status", text, 120, 230, 10, "Calibri Bold", CLR_NONE, CL);

   text=">Rule discovery: all the pairs";
   CL=White;
   if (open_right_only) {
      text=">Rule discovery: the sign (and slot)";
      CL=Lime;
   }
   Object_field("rule", text, 120, 140, 10, "Calibri Bold", CLR_NONE, CL);

   text="unavailable";
   CL=Gray;
   if (longs_allowed){
      text=">buy";
      CL=DeepSkyBlue;
   }
   else {
      text="Buys";
      CL=DarkGray;
   }
   
   Object_field("open_longs", text, 120, 160, 10, "Calibri", CLR_NONE, CL);

   text="unavailable";
   CL=Gray;
   if (shorts_allowed){
      text=">sell";
      CL=Orange;
   }
   else {
      text="Sells";
      CL=DarkGray;
   }
   
   Object_field("open_shorts", text, 120, 180, 10, "Calibri", CLR_NONE, CL);
   
   Object_field("close", ">Close all", 120, 200, 10, "Calibri", CLR_NONE, Red);
   
   Object_field("close2", ">Close in profit", 200, 200, 10, "Calibri", CLR_NONE, Red);
   Object_field("brkev", ">StopLoss++", 260, 160, 10, "Calibri", CLR_NONE, Yellow);
   Object_field("brkev2", ">StopLoss--", 260, 180, 10, "Calibri", CLR_NONE, Yellow);
   Object_field("closel", ">close", 190, 160, 10, "Calibri", CLR_NONE, DeepSkyBlue);
   Object_field("closes", ">close", 190, 180, 10, "Calibri", CLR_NONE, Orange);

//+------------------------------------------------------------------+
//|    FACILITIES MANAGEMENT TRAILING                             
//+------------------------------------------------------------------+
   Object_field("etrail", "_TRAILING_", 115, 130, 10, "Calibri Bold", CLR_NONE, White,90);

   if (start_trail_val ==0)   text=">percent, "+DoubleToStr(start_trail_temp,1)+"%/"+trail2+"%";
   else text=">in the currency, "+DoubleToStr(start_trail_val,0)+"/"+DoubleToStr(trail_val,1)+" "+AccountCurrency( );
   if (preset_trail)          CL=Lime; else CL=Gray;
   Object_field("etrail1", text, 140,  60, 10, "Calibri Bold", CLR_NONE, CL);

   if (atr_tral) CL=Lime; else CL=Gray;
   Object_field("etrail2", ">settlement of ATR "+DoubleToStr(start_trail*atr*(AccountBalance()/100),0)
   +"/"+DoubleToStr(trail*atr*(AccountBalance()/100),0), 140,  80, 10, "Calibri Bold", CLR_NONE, CL);
   
//   Object_field("lock", "On: ", 140, 100, 10, "Calibri Bold", CLR_NONE, Orange);

   string Srift;
   
   if (auto_tral) {Srift="Calibri Bold"; CL=White; } else {Srift="Calibri"; CL=Gray;}
   Object_field("adapt", ">Machine:", 140, 100, 10, Srift, CLR_NONE, CL);
   
   if (wpr_tral) {Srift="Calibri Bold"; CL=Lime; } else {Srift="Calibri"; CL=Gray;}
   Object_field("lockwpr", "WPR", 200, 100, 10, Srift, CLR_NONE, CL);

   
   if (dto_tral) {Srift="Calibri Bold"; CL=Lime;}else {Srift="Calibri"; CL=Gray;}
   Object_field("lockdto", "DTO", 235, 100, 10, Srift, CL,CL);
   

   if (rsi_tral)  {Srift="Calibri Bold"; CL=Lime;}else {Srift="Calibri"; CL=Gray;}
   Object_field("lockrsi", "RSI", 270, 100, 10, Srift, CLR_NONE, CL);
   
   if (preset_trail||atr_tral||wpr_tral||dto_tral||rsi_tral||auto_tral) {
      text=">Disable all trials";
      Srift="Calibri Bold";
      CL=Lime;
   }
   else {
      text="";
      CL=CLR_NONE;
   }
   Object_field("trail_off", text, 140, 120, 10, Srift, CLR_NONE, CL);
//+------------------------------------------------------------------+
//|    COUNTERS                           
//+------------------------------------------------------------------+    
   string short_pips2=DoubleToStr(short_pips,0);
   string long_pips2=DoubleToStr(long_pips,0);
   string total_pips2=DoubleToStr(total_pips,0);
   string highest_total_pips2=DoubleToStr(highest_total_pips,0);
   string highest_short_pips2=DoubleToStr(highest_short_pips,0);
   string highest_long_pips2=DoubleToStr(highest_long_pips,0);

   Object_field("l_pips",  "Counter  LONGS: "+long_pips2+"/"+highest_long_pips2, 5, 360, 10, "Consolas Bold", CLR_NONE, Lime);
   Object_field("s_pips",  "Counter SHORTS: "+short_pips2+"/"+highest_short_pips2, 5, 380, 10, "Consolas Bold", CLR_NONE, Orange);
   Object_field("tot_pips","Counter  TOTAL: "+total_pips2+"/"+highest_total_pips2+", Roll cart: "
   +DoubleToStr(MathAbs(highest_total_pips-total_pips),0), 5, 400, 10, "Consolas Bold", CLR_NONE, Aqua);
   Object_field("exterm", "Extremes: LONGS= "+DoubleToStr(GlobalVariableGet("maxtotal_long"),0)+
   ", SHORTS= "+DoubleToStr(GlobalVariableGet("maxtotal_short"),0), 5, 420, 10, "Consolas Bold", CLR_NONE, White);

   Object_field("l_pips2"," Advisor of Orders  BUY: "+buys+", Profit: "+iBuyTradeProfit+" "
   +AccountCurrency(), 180, 360, 10, "Consolas", CLR_NONE, Lime);
   Object_field("s_pips2"," Advisor of Orders SELL: "+sells+", Profit: "+iSellTradeProfit+" "
   +AccountCurrency(), 180, 380, 10, "Consolas", CLR_NONE, Orange);  
   Object_field("title_rev", "Reverse the basket:", 120, 300, 10, "Calibri Bold", CLR_NONE, White);  

   
   if (exit_on_reverse){
      if (can_trade) {
         text=">close/wait conditions";
         Srift="Calibri Bold";
         CL=Gold;      
      } else {
         text=">close positions";
         Srift="Calibri Bold";
         CL=Red;
      }
   } else {
      text=">ignore";
      Srift="Calibri";
      CL=Gray;
   }
   Object_field("exonr", text, 120, 320, 10, Srift, CLR_NONE, CL);  


   if (time_restriction==false)
      Object_field("tyme", "In-session Limit!", 140, 275, 12, "Calibri", Red, White,45);  
   else 
      if (ObjectFind("tyme") != -1 )ObjectDelete("tyme");
   if (only_profit==true && update_stop==false) Object_field("trgt", ">Stop: "+target3+" "+AccountCurrency()
   +", ("+target2+"%)", 120, 40, 10, "Calibri Bold", Red, Red);
   else 
   {
   if (pcntd > 0)Object_field("trgt", ">Stop: "+target3+" "+AccountCurrency()
   +", ("+target2+"%)", 120, 40, 10, "Calibri Bold", Lime, Lime);
   if (pcntd <= 0)Object_field("trgt", ">Stop: "+target3+" "+AccountCurrency()
   +", ("+target2+"%)", 120, 40, 10, "Calibri Bold", Gold, Gold);
   }
   
//+------------------------------------------------------------------+
//|     SIGNALS                              
//+------------------------------------------------------------------+   
   
   if (wpr_val <= -80) {CL=Lime; text=CharToStr(221);}
   if (wpr_val > -80 && wpr_val <-20) { CL=Yellow; text=CharToStr(0xF4);}
   if (wpr_val >=-20) { CL=Red; text= CharToStr(222);}
   Object_field("wpr_sem", text, 470, 30, 32, "Wingdings", CL, CL);
   Object_field("wpr_sem_l", "WPR", 478, 80, 10, "Consolas", Red, Silver);
   
   if (dtom < 50 && delta_dtom >0){ CL=Lime; text=CharToStr(221);}
   if ((dtom >= 50 && delta_dtom >0) || (dtom <= 50 && delta_dtom <0)) { CL=Yellow; text=CharToStr(0xF4);}
   if (dtom > 50 && delta_dtom <0) { CL=Red; text= CharToStr(222);  }
   Object_field("dto_sem", text, 470, 110, 32, "Wingdings", CL, CL);
   Object_field("dto_sem_l", "DTO", 478, 160, 10, "Consolas", Red, Silver);

   CL=Yellow;
   if (rsi_val <= 35 || delta_rsi >0) {CL=Lime; text=CharToStr(221);}
   if (rsi_val >= 65 || delta_rsi <0) {CL=Red; text= CharToStr(222);  }
   Object_field("rsi_sem", text, 470, 190, 32, "Wingdings", CL, CL);
   Object_field("rsi_sem_l", "RSI", 478, 240, 10, "Consolas", Red, Silver);

   if (rvi_val > 0){ CL=Lime; text=CharToStr(221);}
   if (rvi_val <= 0){ CL=Red; text= CharToStr(222);  }
   Object_field("rvi_sem", text, 470, 270, 32, "Wingdings", CL, CL);
   Object_field("rvi_sem_l", "RVI", 478, 320, 10, "Consolas", Red, Silver);

//+------------------------------------------------------------------+
//|     MANAGEMENT - LOT SIZE                              
//+------------------------------------------------------------------+  

   if (Maximum_Risk !=0) 
   {
   Object_field("x"+i, "   Lot Size determines advisor", 40*i, 460, 10, "Calibri", Red, White);
   } else {
   for (i=1;i<=10;i++)
   if (i==lot_mtp) 
   {CL=Lime;
   Object_field("x"+i, CharToStr(0x8B+i), 40*i, 460, 14, "Wingdings", Red, CL);
   } else 
   {CL=White;
   Object_field("x"+i, CharToStr(0x8B+i), 40*i, 460, 14, "Wingdings", Red, CL); 
   }
   }
   
return;
} //draw_objects  

//+------------------------------------------------------------------+
//|     CLOSURE OF ALL OPEN TRADES                                   |
//+------------------------------------------------------------------+
void close()
{
   ObjectSetText("status","Mode: closing of positions", mode_font_size,"Calibri Bold",Red);
   open_buys=false;open_sells=false;
   int    i,type,err;
   double price;
   bool   result;
   //----

   for(i=OrdersTotal()-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {
         type=OrderType();
         if((type==OP_BUY && OrderMagicNumber() == Magic) || ( type==OP_SELL && OrderMagicNumber() == Magic))
            {
            while(true)
               {
               if(type==OP_BUY) price=MarketInfo(OrderSymbol(),MODE_BID);
               else price=MarketInfo(OrderSymbol(),MODE_ASK);
               result=OrderClose(OrderTicket(),OrderLots(),price,slippage,CLR_NONE);
               if(result!=true) {err=GetLastError(); Print("Current Error = ",err);}
               else err=0;
               if(err==135) RefreshRates();
               else break;
         }  }  }
      else Print( "Error ",GetLastError()," the performance of the order");
      }
   for (i=0;i<=long_step;i++) if (ObjectFind(buy_comm+i)==0) ObjectDelete(buy_comm+i);
   for (i=0;i<=short_step;i++) if (ObjectFind(sell_comm+i)==0) ObjectDelete(sell_comm+i);     
   return;
   }
//+------------------------------------------------------------------+
//|     CLOSE PROFITABLE TRADES                               
//+------------------------------------------------------------------+
void close_win()
{
   ObjectSetText("status","Mode: Close winners", mode_font_size,"Calibri Bold",Red);
   int    i,type,err;
   double price;
   bool   result;
//----
   for(i=OrdersTotal()-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {
         type=OrderType();
         if(((type==OP_BUY && OrderMagicNumber() == Magic) || (type==OP_SELL && OrderMagicNumber() == Magic)) && OrderProfit()>0)
            {
            while(true)
               {
               if(type==OP_BUY) price=MarketInfo(OrderSymbol(),MODE_BID);
               else price=MarketInfo(OrderSymbol(),MODE_ASK);
               result=OrderClose(OrderTicket(),OrderLots(),price,slippage,CLR_NONE);
               if(result!=true) {err=GetLastError(); Print("Current Error = ",err);}
               else err=0;
               if(err==135) RefreshRates();
               else break;
         }  }  }
      else Print( "Error ",GetLastError()," the performance of the order");
      }
   return;
   }
//+------------------------------------------------------------------+
//|     CLOSE LONG TRADES                               
//+------------------------------------------------------------------+
void close_longs()
{
   shorts_allowed=true;
   ObjectSetText("status","Mode: Closing Buys", mode_font_size,"Calibri Bold",Red);
   open_buys=false;open_sells=false;
   int    i,type,err;
   double price;
   bool   result;
//----
   
   for(i=OrdersTotal()-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {
         type=OrderType();
         if(type==OP_BUY && OrderMagicNumber() == Magic)
            {
            while(true)
               {
               result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),slippage,CLR_NONE);
               if(result!=true) {err=GetLastError(); Print("Current Error = ",err);}
               else err=0;
               if(err==135) RefreshRates();
               else break;
         }  }  }
      else Print( "Error ",GetLastError()," the performance of the order");
      }
      for (i=0;i<=long_step;i++) if (ObjectFind(buy_comm+i)==0) ObjectDelete(buy_comm+i);      
      return;
   }
//+------------------------------------------------------------------+
//|     CLOSE SHORT TRADES                                
//+------------------------------------------------------------------+
void close_shorts()
{
   ObjectSetText("status","Mode: Closing sells", mode_font_size,"Calibri Bold",Orange);
   open_buys=false;open_sells=false;
   int    i,type,err;
   double price;
   bool   result;
//----

   for(i=OrdersTotal()-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {
         type=OrderType();
         if(type==OP_SELL && OrderMagicNumber() == Magic)
            {
            while(true)
               {
               result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),slippage,CLR_NONE);
               if(result!=true) {err=GetLastError(); Print("Current Error = ",err);}
               else err=0;
               if(err==135) RefreshRates();
               else break;
         }  }  }
      else Print( "Error ",GetLastError()," the performance of the order");
      }
   for (i=0;i<=short_step;i++) if (ObjectFind(sell_comm+i)==0) ObjectDelete(sell_comm+i);
     return;
   }

//+------------------------------------------------------------------+
//|     STOP PLACEMENT                              
//+------------------------------------------------------------------+
void breakeven()
{
   ObjectSetText("status","Mode: setting stops", mode_font_size,"Calibri Bold",Yellow);
   int totalorders = OrdersTotal();
   double SL;
   int digits;
   for(int i=totalorders-1;i>=0;i--)
      {
      OrderSelect(i, SELECT_BY_POS);
         {
         digits=MarketInfo(OrderSymbol(),MODE_DIGITS);
         if ( OrderType() == OP_BUY && OrderMagicNumber() == Magic) 
            {
            SL= MarketInfo(OrderSymbol(),MODE_BID)-sl*MarketInfo(OrderSymbol(),MODE_POINT);
            if (SL > OrderStopLoss() || OrderStopLoss()==0) OrderModifyReliableSymbol(OrderSymbol(),OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL,digits),OrderTakeProfit(),0,CLR_NONE);
            }          
         if ( OrderType() == OP_SELL && OrderMagicNumber() == Magic) 
            {
            SL= MarketInfo(OrderSymbol(),MODE_ASK)+sl*MarketInfo(OrderSymbol(),MODE_POINT);
            if (SL < OrderStopLoss() || OrderStopLoss()==0) OrderModifyReliableSymbol(OrderSymbol(),OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL,digits),OrderTakeProfit(),0,CLR_NONE);
            }
         }
      }
return;
}


//+------------------------------------------------------------------+
//|     REMOVE STOPS                               
//+------------------------------------------------------------------+
void removesl()
{
   ObjectSetText("status","Mode: deleting stops", mode_font_size,"Calibri Bold",Yellow);
   int totalorders = OrdersTotal();
   for(int i=totalorders-1;i>=0;i--)
   {
   OrderSelect(i, SELECT_BY_POS);
      {
      if ( OrderType() == OP_BUY && OrderMagicNumber() == Magic) 
         {
         OrderModifyReliable(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),0,CLR_NONE);
         }          
      if ( OrderType() == OP_SELL && OrderMagicNumber() == Magic) 
         {
         OrderModifyReliable(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),0,CLR_NONE);
         }
      }
   }
return;
}

//+------------------------------------------------------------------+
//| BUYING BASKET ADVISOR                                       |
//+------------------------------------------------------------------+
int t101buy()
{
   long_step=GlobalVariableGet("long_step")+1;
   orders();
   ObjectSetText("status","Mode: Buy", mode_font_size,"Calibri Bold",Lime);
   if (!open_right_only) //Open all the lesson regardless of the sign and position in the group
   {
   for (int i=0;i<CountSymbol;i++)
      {  
      if (lb[i]==0) OrderSendReliable(long_basket[i],OP_BUY, LotsOptimized(long_basket[i]), MarketInfo(long_basket[i],MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
      if (sb[i]==0) OrderSendReliable(short_basket[i],OP_BUY, LotsOptimized(short_basket[i]), MarketInfo(short_basket[i],MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
      }
   }
else
   {
   for (i=0;i<CountSymbol;i++)
      {  
      if ( LB_pips[i] >0 && lb[i]==0) OrderSendReliable(long_basket[i],OP_BUY, LotsOptimized(long_basket[i]), MarketInfo(long_basket[i],MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
      if ( SB_pips[i] <0 && sb[i]==0) OrderSendReliable(short_basket[i],OP_BUY, LotsOptimized(short_basket[i]), MarketInfo(short_basket[i],MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
      }
   }
   orders();
   return;
}
//+------------------------------------------------------------------+
//| BUY BASKET MANUALLY                                              |
//+------------------------------------------------------------------+
int t101man_buy()
{
   long_step=GlobalVariableGet("long_step")+1;
   orders();
   ObjectSetText("status","Mode: Buy", mode_font_size,"Calibri Bold",Lime);
   if (!open_right_only) //Open all the lesson regardless of the sign and position in the group 
   {
   for (int i=0;i<CountSymbol;i++)
      {  
      OrderSendReliable(long_basket[i],OP_BUY, LotsOptimized(long_basket[i]), MarketInfo(long_basket[i],MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
      OrderSendReliable(short_basket[i],OP_BUY, LotsOptimized(short_basket[i]), MarketInfo(short_basket[i],MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
      }
   }
else
   {
   for (i=0;i<CountSymbol;i++)
      {  
      if ( LB_pips[i] >0) OrderSendReliable(long_basket[i],OP_BUY, LotsOptimized(long_basket[i]), MarketInfo(long_basket[i],MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
      if ( SB_pips[i] <0) OrderSendReliable(short_basket[i],OP_BUY, LotsOptimized(short_basket[i]), MarketInfo(short_basket[i],MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
      }
   }
   orders();
   return;
}
//+------------------------------------------------------------------+
//| SELLING BASKET ADVISOR                                        |
//+------------------------------------------------------------------+
int t101sell()
{
   short_step=GlobalVariableGet("short_step")+1;
   orders();
   ObjectSetText("status","Mode: sell", mode_font_size,"Calibri Bold",Red);
   if (!open_right_only) //Open all the lesson regardless of position in the group
   {
   for (int i=0;i<CountSymbol;i++)
      {
      if (lb[i]==0) OrderSendReliable(long_basket[i],OP_SELL, LotsOptimized(long_basket[i]), MarketInfo(long_basket[i],MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
      if (sb[i]==0) OrderSendReliable(short_basket[i],OP_SELL, LotsOptimized(short_basket[i]), MarketInfo(short_basket[i],MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
      }
  }
else
   {
   for (i=0;i<CountSymbol;i++)
      {
      if ( LB_pips[i] <0 && lb[i]==0)OrderSendReliable(long_basket[i],OP_SELL, LotsOptimized(long_basket[i]), MarketInfo(long_basket[i],MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
      if ( SB_pips[i] >0 && sb[i]==0)OrderSendReliable(short_basket[i],OP_SELL, LotsOptimized(short_basket[i]), MarketInfo(short_basket[i],MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
      }
  }
   orders();
   return;
}
//+------------------------------------------------------------------+
//| SELL BASKET MANUALLY                                             |
//+------------------------------------------------------------------+
int t101man_sell()
{
   short_step=GlobalVariableGet("short_step")+1;
   orders();
   ObjectSetText("status","Mode: sell", mode_font_size,"Calibri Bold",Red);
   if (!open_right_only) //Open every lesson regardless of position in the group
   {
   for (int i=0;i<CountSymbol;i++)
      {
      OrderSendReliable(long_basket[i],OP_SELL, LotsOptimized(long_basket[i]), MarketInfo(long_basket[i],MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
      OrderSendReliable(short_basket[i],OP_SELL, LotsOptimized(short_basket[i]), MarketInfo(short_basket[i],MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
      }
  }
else
   {
   for (i=0;i<CountSymbol;i++)
      {
      if ( LB_pips[i] <0) OrderSendReliable(long_basket[i],OP_SELL, LotsOptimized(long_basket[i]), MarketInfo(long_basket[i],MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
      if ( SB_pips[i] >0) OrderSendReliable(short_basket[i],OP_SELL, LotsOptimized(short_basket[i]), MarketInfo(short_basket[i],MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
      }
  }
   orders();
   return;
}
//+------------------------------------------------------------------+
//|     MANUAL TRADE                             
//+------------------------------------------------------------------+
void draw_field() {
   Object_field("banner2", "", 380,  30, 10, "Calibri"     , CLR_NONE, Yellow, 270);
   Object_field("banner3", "", 350,  30, 10, "Calibri"     , CLR_NONE, Yellow, 270);
   Object_field("banner4", "", 440,  30, 10, "Calibri"     , CLR_NONE, Yellow, 270);
   Object_field("banner5", "SELLS"                    , 340, 220, 16, "Calibri Bold", CLR_NONE, Red   ,  90);
   Object_field("banner6", "BUYS"                    , 430, 220, 16, "Calibri Bold", CLR_NONE, Lime  ,  90);
   Object_field("banner7", "", 470,  30, 10, "Calibri",      CLR_NONE, Yellow, 270);
   Object_field("banner11", "===========================================================", 530,  30, 10, "Calibri",      CLR_NONE, Yellow, 270);

// GRID   
   int i;
   string name;
   for (i=0;i<CountSymbol;i++) {
      name=(i+1)+"l";
      Object_field(name     , long_basket[i]               , 380,  40+i*20, 10, "Consolas Bold",  Red     , Lime       );
      if (ObjectGet(name, OBJPROP_XDISTANCE) < 360) {ObjectDelete("banner5");
         manual_sell(long_basket[i]);
         ObjectDelete(name);
      }
      if (ObjectGet(name, OBJPROP_XDISTANCE) > 440) {ObjectDelete("banner6");
         manual_buy(long_basket[i]);
         ObjectDelete("1l");
      }
   }
   for (i=0;i<CountSymbol;i++) {
      name=(i+1)+"s";
      Object_field(name    , short_basket[i]              , 380, 200+i*20, 10, "Consolas Bold",  Red     , Red        );
      if (ObjectGet(name, OBJPROP_XDISTANCE) < 360) {ObjectDelete("banner5");
         manual_sell(short_basket[i]);
         ObjectDelete(name);  
      }
      if (ObjectGet(name, OBJPROP_XDISTANCE) > 440) {ObjectDelete("banner6");
         manual_buy(short_basket[i]);
         ObjectDelete(name);  
      }
   }
}

// Manual sell 
void manual_sell(string symbol)
{
   int answ=confirm("Sell "+symbol+"\nContinue?", "Confirmation of the transaction", MB_YESNO);
   if(answ==IDYES) 
   {
   short_step=GlobalVariableGet("short_step")+1;
   OrderSendReliable(symbol,OP_SELL, LotsOptimized(symbol), MarketInfo(symbol,MODE_BID), slippage, NULL, NULL, sell_comm+short_step, Magic, 0, CLR_NONE);
   }
   return;
}
void manual_buy(string symbol)
{
   int answ=confirm("Buy "+symbol+"\nContinue?", "Confirmation of the transaction", MB_YESNO);
   if(answ==IDYES) 
   {
   long_step=GlobalVariableGet("long_step")+1;
   OrderSendReliable(symbol,OP_BUY, LotsOptimized(symbol), MarketInfo(symbol,MODE_ASK), slippage, NULL, NULL, buy_comm+long_step, Magic, 0, CLR_NONE);
   }
   return;
}
//+------------------------------------------------------------------+
//|     CONVERSION AND WITHDRAWAL OF OPEN POSITIONS                  | 
//+------------------------------------------------------------------+
void  view_baskets()
{
   double profit;
   int    i,index,type,total=OrdersTotal(),ilong_step,ishort_step;
   color CL;
   
   basket_long=0;
   basket_short=0;
   long_step=0;
   short_step=0;

   ArrayInitialize(Basket,-1);
   ArrayInitialize(BuySumm,0);
   ArrayInitialize(SellSumm,0);
   
   for(i=0; i<total; i++) // If the basket was installed or closed with another terminal, look for the most senior to the number of comments 
   {                       // And assign it a variable number long_step 
         if(!OrderSelect(i,SELECT_BY_POS)) continue; 
         type=OrderType();
         if (type==OP_BUY)
         {
         ilong_step=StrToInteger(StringSubstr( OrderComment(), StringLen(buy_comm), 0));
            if (ilong_step>long_step) 
               {
               long_step=ilong_step;
               }
         profit=OrderProfit()+OrderCommission()+OrderSwap();
         index=BasketIndexLong(ilong_step,type);
         if (index >= 0)
            {
            BuySumm[index][0]++;             // Number of orders in the basket 
            BuySumm[index][1]+=OrderLots();  // Total lot Basket 
            BuySumm[index][2]+=profit;       // Total Profit Basket
            }
         }
   }         
   for(i=0; i<total; i++) // If the basket was installed or closed with another terminal, looking for showing the highest number in comments 
   {                       // And assigning it the number of variable short_step 
         if(!OrderSelect(i,SELECT_BY_POS)) continue; 
         type=OrderType();         
         if (type==OP_SELL)
         {
         ishort_step=StrToInteger(StringSubstr( OrderComment(), StringLen(sell_comm), 0));
            if (ishort_step>short_step) 
               {
               short_step=ishort_step;
               }
         profit=OrderProfit()+OrderCommission()+OrderSwap();
         index=BasketIndexShort(ishort_step,type);
         if (index >= 0)
            {
            SellSumm[index][0]++;
            SellSumm[index][1]+=OrderLots();
            SellSumm[index][2]+=profit;
            }
         }
   }

//+------------------------------------------------------------------+
//|     WITHDRAWAL OF OPEN POSITIONS                                 |
//+------------------------------------------------------------------+  
    Object_field("terminator", "!!! ZONE Closed Position !!!", 540, 30, 10, "Calibri Bold", Red, Red);
    ObjectSet("terminator",OBJPROP_BACK,true);
    string text="Trash     Par      Lot          Profit";
    Object_field("terminator1", text, 540, 50, 10, "Calibri Bold", Red, White);
    Object_field("terminator2", text, 540, 290, 10, "Calibri Bold", Red, White);

   int j=0;
   for (i=0;i<15;i++)               // Limiting Output -16 lines

         if (BuySumm[i][0]==0) 
         {
         if (ObjectFind(buy_comm+i)==0) ObjectDelete(buy_comm+i);
         continue;
         } else 
         { j++;
         if (BuySumm[i][2] >=0) {CL=Lime;} else {CL=Red;}
         Object_field(buy_comm+i, BasketNameLong[i]+":   "+DoubleToStr(BuySumm[i][0],0)+
         "   "+DoubleToStr(BuySumm[i][1],2)+"   "+DoubleToStr(BuySumm[i][2],1), 535,  50+j*15, 9, "Consolas", Red, CL);
         } 

         
    j=0;     
    for (i=0;i<15;i++)              // Limiting Output -16 lines

         if (SellSumm[i][0] ==0) 
         {
         if (ObjectFind(sell_comm+i)==0) ObjectDelete(sell_comm+i);
         continue;
         } else 
         { j++;
         if (SellSumm[i][2] >=0) {CL=Lime;} else {CL=Red;}  
         Object_field(sell_comm+i, BasketNameShort[i]+":   "+DoubleToStr(SellSumm[i][0],0)+
         "   "+DoubleToStr(SellSumm[i][1],2)+"   "+DoubleToStr(SellSumm[i][2],1), 535,  290+j*15, 9, "Consolas", Red, CL);
         }

   return;
  }
//+------------------------------------------------------------------+
//|      INDEXING OPEN POSITIONS                                     |
//+------------------------------------------------------------------+
int BasketIndexLong(int Comm,int type)
  {
   bool found=false;
   
if (type==0)
   {
   for(int i=0; i<basket_long; i++)

     {
      
      if(Comm==Basket[i][0])
        {
         found=true;
         break;
        }

     }
//----
   if(found) return(i);
   if (basket_long>15) return (-1);
   i=basket_long;
   basket_long++;
   Basket[i][0]=Comm;
   BasketNameLong[i] = OrderComment();
   BuySumm[i][0]=0;
   BuySumm[i][1]=0;
   BuySumm[i][2]=0;
   
   return(i);
   } 
}

int BasketIndexShort(int Comm,int type)
{
   bool found=false;   
   if (type==1)
   {
   for(int i=0; i<basket_short; i++)

     {
      
      if(Comm==Basket[i][1])
        {
         found=true;
         break;
        }

     }

   if(found) return(i);
   if (basket_short>15) return (-1);
   i=basket_short;
   basket_short++;
   Basket[i][1]=Comm;
   BasketNameShort[i] = OrderComment();
   SellSumm[i][0]=0;
   SellSumm[i][1]=0;
   SellSumm[i][2]=0;

   return(i);
   }
}   

//+------------------------------------------------------------------+
//|      CALCULATION OF PROFITS                                      |
//+------------------------------------------------------------------+
int CalculatePipsProfit()
   {
      //int Profit=0;
      iBuyTradeProfit=0;
      iSellTradeProfit=0;
      BuyTradeProfit =0;
      SellTradeProfit =0;
      for (int i=0; i<OrdersTotal(); i++) 
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      
            if (OrderType()==OP_BUY && OrderMagicNumber() == Magic) BuyTradeProfit += (OrderProfit()+OrderCommission()+OrderSwap()); //(MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())*multiplier;
            if (OrderType()==OP_SELL && OrderMagicNumber() == Magic) SellTradeProfit += (OrderProfit()+OrderCommission()+OrderSwap());//(OrderOpenPrice()-MarketInfo(OrderSymbol(), MODE_ASK))*multiplier;
      }//for 

           BuyTradeProfit = NormalizeDouble(BuyTradeProfit,0);
           SellTradeProfit = NormalizeDouble(SellTradeProfit,0);
            iBuyTradeProfit=BuyTradeProfit;
            iSellTradeProfit=SellTradeProfit;
      
      return;
   }// end CalculatePipsProfit()
 
//+------------------------------------------------------------------+
//| TIMER                                                            |
//+------------------------------------------------------------------+   
void timer_set()
{


if (ObjectGet("timer",OBJPROP_COLOR)==Lime) timercolor=DarkSlateGray; else timercolor=Lime;

if (timer)
   {
   ObjectSetText("timer",">TIMER: "+ DoubleToStr(delay,0)+" ms.", 10,"Calibri Bold",timercolor);
   } else { ObjectSetText("timer",">UZ QUOTES", 10,"Calibri Bold",timercolor);}
if (!IsConnected())
{
ObjectSetText("timer","Precipice, Crawling your server", 10,"Calibri Bold",Red);
reconn();
}
if (ObjectGet("timer", OBJPROP_XDISTANCE) != 120)
{
if (confirm("Toggle START. \nContinue?", "Confirm the operation", MB_YESNO)==IDYES)
   {
   if (timer==false)  timer=true;
   else timer=false;
   }
   ObjectDelete("timer");
}
return;
}

//+------------------------------------------------------------------+
//| INDICATOR CALCULATION                                            |
//+------------------------------------------------------------------+  
int check_indi() 
{
   int j;
   double temp=0;
      
      for(j = 0; j < num_pair; j++) // calculation RSI
      {
           temp = temp + iRSI(Pairs[j],tf,rsi_per,PRICE_CLOSE,0);
      }
       rsi_val = MathRound(temp/num_pair);
       
      temp=0;
      for(j = 0; j < num_pair; j++)
      {
      temp = temp+(iRSI(Pairs[j],tf,rsi_per,PRICE_CLOSE,0)-iRSI(Pairs[j],tf,rsi_per,PRICE_CLOSE,1)); 
      delta_rsi=temp/num_pair*10;
      }        
    
      temp=0;       
      for(j = 0; j < num_pair; j++) 
      {
           temp = temp + iWPR(Pairs[j], tf, 14, 0);
      }
       wpr_val = MathRound(temp/num_pair);
      
      temp=0;
      for(j = 0; j < num_pair; j++) 
      {
           temp = temp + iATR(Pairs[j], 5, 14, 0);
      }
      temp = temp/num_pair*100;
      atr_val = NormalizeDouble(temp/4,1); 
      
      temp=0;
      for(j = 0; j < num_pair; j++)
      {
      temp = temp+iCustom(Pairs[j],tf,"DTOsc",rsi_per,K,S,D,true,0,0); 
      }
      dtom = MathRound(temp/num_pair); 
       
      temp=0;
      for(j = 0; j < num_pair; j++)
      {
      temp = temp+iCustom(Pairs[j],tf,"DTOsc",rsi_per,K,S,D,true,1,0); 
      }
      dtom_sig = MathRound(temp/num_pair);   
      delta_dtom=MathRound(dtom-dtom_sig);
      
      temp=0;
      for(j = 0; j < num_pair; j++)
      {
      temp = temp+(iRVI(Pairs[j],tf,rvi_per,0,0)-iRVI(Pairs[j],tf,rvi_per,1,0)); 
      rvi_val=temp/num_pair*1000;
      }             

      return;   
}
//+------------------------------------------------------------------+
//| CALCULATION oF THE MOVING STOP                                   |
//+------------------------------------------------------------------+  
int check_pcnt()
{
if (AccountMargin()!=0)
{
i_pcnt = AccountEquity( )/AccountMargin( )*Maximum_Risk;
i_pcnt = NormalizeDouble(i_pcnt,1);
if (i_pcnt > Stop) i_pcnt=Stop;
}
return(0);
}
//+------------------------------------------------------------------+
//| INSTALLATION / TESTING GLOBAL VARIABLES                          |
//+------------------------------------------------------------------+ 
void InitGlobalValue()
{
    if (GlobalVariableCheck("maxlong")==false) GlobalVariableSet("maxlong",0);
    if (GlobalVariableCheck("maxshort")==false) GlobalVariableSet("maxshort",0);
    if (GlobalVariableCheck("maxtotal")==false) GlobalVariableSet("maxtotal",0);
    highest_total_pips=GlobalVariableGet("maxtotal");    
    if (GlobalVariableCheck("zero_point")==false && move_zp==false) GlobalVariableSet("zero_point",zero_point);
    if (GlobalVariableCheck("zero_point")==false && move_zp==true) 
      {
      zero_point=iTime(NULL,1440,0);
      GlobalVariableSet("zero_point",zero_point);
      }
    zero_point=GlobalVariableGet("zero_point");
    if (GlobalVariableCheck("zp_short")==false) GlobalVariableSet("zp_short",zp_short);
    if (GlobalVariableCheck("zp_long")==false) GlobalVariableSet("zp_long",zp_long);
    
    if (GlobalVariableCheck("long_step")==false) GlobalVariableSet("long_step",long_step); // Counter - Buy discoveries
    if (GlobalVariableCheck("short_step")==false) GlobalVariableSet("short_step",short_step); // Counter - Sell discoveries     
    
    return;
}

//+------------------------------------------------------------------+
//|  CLOSE BASKET POSITIONS                                          |                             
//+------------------------------------------------------------------+
void close_basket(int OP, string Comm)
{
ObjectSetText("status","Mode: closing "+Comm, mode_font_size,"Calibri Bold",Red);
open_buys=false;open_sells=false;
   int    i,type,err;
   int pos;
   string symb;
   bool   result;
   bool find=false;
//----
   for(i=OrdersTotal()-1;i>=0;i--) 
   {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))   continue;
      if (OrderComment() != Comm)                     continue;
      if (OrderType()!=OP)                            continue;
     
     // pos=SArrayBsearh(long_basket,OrderSymbol());
         if (OP==OP_BUY) result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),slippage,CLR_NONE);
         if (OP==OP_SELL)result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),slippage,CLR_NONE);

         if(result!=true) {err=GetLastError(); Print("LastError = ",err);} else  {err=0;}
    }
   return(err);
}
/*  
//+------------------------------------------------------------------+
//    SEARCH IN MASS
//+------------------------------------------------------------------+
int SArrayBsearh(string array[], string value){
   for (int j=0;j<ArraySize(array);j++) 
      if (value==array[j]) return(j);
   return(-1);
}
*/
//+------------------------------------------------------------------+
//    TEST NEW BAR FOR A GIVEN TIMEFRAME
//+------------------------------------------------------------------+
bool IsNewBar(int timeFrame)
   {
   bool res=false;
   
   static datetime _sTime[9]; // array opening of the current (zero) bar from 9 FF
   int i;
 
   switch (timeFrame) 
      {
      case 1  : i=0; break;
      case 5  : i=1; break;
      case 15 : i=2; break;
      case 30 : i=3; break;
      case 60 : i=4; break;
      case 240: i=5;break;
      case 1440:i=6;break;
      case 10080:i=7;break;
      case 43200:i=8;break;
      default:  timeFrame = tf;
      }
//----
   if (_sTime[i]==0 || _sTime[i]!=iTime("GBPJPY",timeFrame,0)) // Using "moving" a couple
      {
      _sTime[i] = iTime("GBPJPY",timeFrame,0);
      res=true;
      }
      
//----
   return(res);   
   }

//+------------------------------------------------------------------+   
//    CLEAR EA WINDOW
//+------------------------------------------------------------------+
void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    ObjectDelete(name);
  }
}
//+------------------------------------------------------------------+
//|   INSPECTION OF OBJECTS                              
//+------------------------------------------------------------------+
void obj_check()
{
if (ObjectGet("auto", OBJPROP_XDISTANCE) != 350) // enable / disable MTS 
   {
   if (confirm("Change the mode of MTS. \nContinue?", "Confirm the operation", MB_YESNO)==IDYES)   
   {
   if (can_trade==true)   can_trade = false; 
   else                   can_trade = true;
   }
   ObjectDelete("auto");   
   return; 
   }
   
if (ObjectGet("trgt", OBJPROP_XDISTANCE) != 120) // enable / disable shift StopLoss 
   {
   if (confirm("Toggle StopLoss. \nContinue?", "Confirm the operation", MB_YESNO)==IDYES)   
      {
      if (only_profit==false ) only_profit = true; 
      else    
      { 
       only_profit = false; 
       starting_target = -Stop;
      }
   }
   ObjectDelete("trgt");   
   return; 
   }
   
if (ObjectGet("rule", OBJPROP_XDISTANCE) != 120) // Rule
   {
   if (confirm("Changing the rules. \nContinue?", "Confirm the operation", MB_YESNO)==IDYES)
   {   
   if (open_right_only==true) 
   {
   open_right_only = false;
   }
   else   open_right_only = true;
   }
   ObjectDelete("rule");
   return; 
   }
if (ObjectGet("open_longs", OBJPROP_XDISTANCE) != 120) // Manual buys
{
   if (confirm("OPEN BUYS. \nContinue?", "Confirm buying", MB_YESNO)==IDYES)
   {
   ObjectSetText("status","Mode: Buying", mode_font_size,"Calibri Bold",Aqua);
   t101man_buy();
   }                      
   ObjectDelete("open_longs");
   return;
}
if (ObjectGet("open_shorts", OBJPROP_XDISTANCE) != 120) // Manual sells
{
   if (confirm("OPEN SELLS. \nContinue?", "Confirm Selling", MB_YESNO)==IDYES)
   {
   ObjectSetText("status","Mode: Selling", mode_font_size,"Calibri Bold",Gold);
   t101man_sell();
   }                      
   ObjectDelete("open_shorts");
   return;
} 

if (ObjectGet("close", OBJPROP_XDISTANCE) != 120) // Close all
{
   if (confirm("CLOSE ALL POSITIONS. \nContinue?", "Confirm close all", MB_YESNO)==IDYES)
   {
   ObjectSetText("status","Mode: closing all positions", mode_font_size,"Calibri Bold",Red);
   close_all=true;
   }                                                       
   ObjectDelete("close");
  return; 
}

if (ObjectGet("close2", OBJPROP_XDISTANCE) != 200) // Close profitable
{
   if (confirm("CLOSE PROFITABLE. \nContinue?", "Confirm close profitable", MB_YESNO)==IDYES)
   {
   ObjectSetText("status","Mode: Close Profitable", mode_font_size,"Calibri Bold",Red);
   close_win();
   }                                                       
   ObjectDelete("close2");
   return; 
}

if (ObjectGet("brkev", OBJPROP_XDISTANCE) != 260) // Move stop to breakeven
{
   if (confirm("Apply/Move STOP LOSS. \nContinue?", "Confirm order change", MB_YESNO)==IDYES)
   {
   ObjectSetText("status","Move Stop to Breakeven", mode_font_size,"Calibri Bold",Yellow);   
   breakeven();
   }                                                       
   ObjectDelete("brkev");
   return; 
}

if (ObjectGet("brkev2", OBJPROP_XDISTANCE) != 260) // Remove the stop
{
   if (confirm("DELETE STOP LOSS. \nContinue?", "Confirm order change", MB_YESNO)==IDYES)
   {
   ObjectSetText("status","Delete Stop Loss", mode_font_size,"Calibri Bold",Yellow);   
   removesl();
   }                                                       
   ObjectDelete("brkev2");
   return; 
}

if (ObjectGet("closel", OBJPROP_XDISTANCE) != 190) // Close buys
{
   if (confirm("CLOSE BUYS. \nContinue?", "Confirm Close Buys", MB_YESNO)==IDYES)
   {
   ObjectSetText("status","Mode: Close Buys", mode_font_size,"Calibri Bold",Red);
   close_l=true;
   }                                                       
   ObjectDelete("closel");
   return; 
}

if (ObjectGet("closes", OBJPROP_XDISTANCE) != 190) // Close Sells
{
   if (confirm("CLOSE SELLS. \nContinue?", "Confirm Close Sells", MB_YESNO)==IDYES)
   {
   ObjectSetText("status","Mode: Close Sells", mode_font_size,"Calibri Bold",Red);
   close_s=true;
   }                                                       
   ObjectDelete("closes");
   return; 
}
//+------------------------------------------------------------------+
//|    FACILITIES MANAGEMENT - TRAILING                             
//+------------------------------------------------------------------+
if (ObjectGet("etrail1", OBJPROP_XDISTANCE) != 140) // sweep in the currency of the deposit, can be combined with a trail on indicators.
{  start_trail=start_trail_temp;
   equity_trail=true;
   preset_trail=true;
   atr_tral=false;
   ObjectDelete("etrail1");
   ObjectDelete("etrail2");
   ObjectDelete("trail_off");
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");
   PlaySound("tick.wav");
   return;                                             
}

if (ObjectGet("etrail2", OBJPROP_XDISTANCE) != 140) // Trail on ATR
{
   ObjectDelete("etrail1");
   ObjectDelete("etrail2");
   ObjectDelete("trail_off");
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");
   equity_trail=true;
   preset_trail=false;
   atr_tral=true;
   PlaySound("tick.wav");
   return;
}

if (ObjectGet("lockwpr", OBJPROP_XDISTANCE) != 200) // Trail on WPR
{
   ObjectDelete("etrail1");
   ObjectDelete("etrail2");
   ObjectDelete("trail_off");
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");
   ObjectDelete("adapt");
   auto_tral=false;
   wpr_tral=true;
   dto_tral=false;
   rsi_tral=false;
   equity_trail=true;
   PlaySound("tick.wav");
   return;
}   

if (ObjectGet("lockdto", OBJPROP_XDISTANCE) != 235) // Trail on DTOsc
{
   ObjectDelete("etrail1");
   ObjectDelete("etrail2");
   ObjectDelete("trail_off");
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");
   ObjectDelete("adapt");
   auto_tral=false;   
   wpr_tral=false;
   dto_tral=true;
   rsi_tral=false;
   equity_trail=true;
   PlaySound("tick.wav");
   return;   
}
if (ObjectGet("lockrsi", OBJPROP_XDISTANCE) != 270) // Trail on RSI
{
   ObjectDelete("etrail1");
   ObjectDelete("etrail2");
   ObjectDelete("trail_off");
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");
   ObjectDelete("adapt");
   auto_tral=false;      
   wpr_tral=false;
   dto_tral=false;
   rsi_tral=true;
   equity_trail=true;
   PlaySound("tick.wav");
   return;   
}

if (ObjectGet("adapt", OBJPROP_XDISTANCE) != 140) // adaptive sweep Indicators
{
   ObjectDelete("etrail1");
   ObjectDelete("etrail2");
   ObjectDelete("trail_off");
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");
   ObjectDelete("adapt");
   auto_tral=true;
   wpr_tral=false;
   dto_tral=false;
   rsi_tral=false;
   equity_trail=true;
   PlaySound("tick.wav");
   return;
 }
//+------------------------------------------------------------------+
//|     PROPERTIES CALCULATION ADAPTIVE TRAILING
//+------------------------------------------------------------------+ 
   if (atr_val >= 0 && atr_val < 2 && auto_tral && dto_tral==false) //adaptive for  DTO
   {
   wpr_tral=false;
   dto_tral=true;
   rsi_tral=false;
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");   
   return;
   }
   
   if (atr_val >= 2 && atr_val < 5 && auto_tral && wpr_tral==false) // adaptive for  WPR
   {
   wpr_tral=true;
   dto_tral=false;
   rsi_tral=false;
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");   
   return;
   }

   if (atr_val >= 5 && auto_tral && rsi_tral==false) //adaptive for  RSI
   {
   wpr_tral=false;
   dto_tral=false;
   rsi_tral=true;
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");   
   return;
   }
   
if (ObjectGet("trail_off", OBJPROP_XDISTANCE) != 140) // Disable Trailing
{
   starting_target=-Stop;
   equity_trail=false;
   preset_trail=false;
   atr_tral=false;
   wpr_tral=false;
   dto_tral=false;
   rsi_tral=false;
   auto_tral=false;  
    
   ObjectDelete("adapt");
   ObjectDelete("etrail1");
   ObjectDelete("etrail2");
   ObjectDelete("trail_off");
   ObjectDelete("lockwpr");
   ObjectDelete("lockdto");
   ObjectDelete("lockrsi");
   PlaySound("tick.wav");
   return;   
}

if (ObjectGet("exonr", OBJPROP_XDISTANCE) != 120) // close when reverse basket
{
   if (confirm("VARY THE EFFECT OF IN-REVERSE. \nContinue?", "Confirm the operation", MB_YESNO)==IDYES)
   {
   if (exit_on_reverse==false) exit_on_reverse=true;                                                       
   else exit_on_reverse=false;
   }
   ObjectDelete("exonr");  
    return;
}
//+------------------------------------------------------------------+
//|    FACILITIES MANAGEMENT LOT SIZE                              
//+------------------------------------------------------------------+ 

if (Maximum_Risk ==0)
   {
   for (int i=1;i<=10;i++) 
   if (ObjectGet("x"+i, OBJPROP_XDISTANCE) != 40*i) // 
    {
    lot_mtp=i;
    PlaySound("tick.wav");
    ObjectDelete("x"+i);
    return;  
    }
    
  }      
//+------------------------------------------------------------------+
//|    OBJECTS DISPLAY OF OPEN POSITIONS 
//+------------------------------------------------------------------+ 

for (i=0;i<=long_step;i++)
   if (ObjectFind(buy_comm+i)==0 && ObjectGet(buy_comm+i,OBJPROP_YDISTANCE) < 40) // Rotated basket Buy
      {
          ObjectDelete("terminator");
          ObjectSet(buy_comm+i,OBJPROP_XDISTANCE,540);
          ObjectSet(buy_comm+i,OBJPROP_YDISTANCE,30);
          if (confirm("CLOSE BASKET "+BasketNameLong[i]+"\nContinue?", "Confirm close basket", MB_YESNO)==IDYES)
          { 
          close_basket(0,BasketNameLong[i]);
    
          }
       return;
       }
       
for (i=0;i<=short_step;i++)
   if (ObjectFind(sell_comm+i)==0 && ObjectGet(sell_comm+i,OBJPROP_YDISTANCE) < 40) // Rotated basket Sell
      {
         ObjectDelete("terminator");
          ObjectSet(sell_comm+i,OBJPROP_XDISTANCE,540);
          ObjectSet(sell_comm+i,OBJPROP_YDISTANCE,30);
         if (confirm("CLOSE BASKET "+BasketNameShort[i]+"\nContinue?", "Confirm close basket", MB_YESNO)==IDYES)
          {
          close_basket(1,BasketNameShort[i]);
          
          
          }
       return;
       }       

return;  //
} //obj_check

//+------------------------------------------------------------------+
//|     CONFIRMATION OF OPERATIONS                                
//+------------------------------------------------------------------+
int confirm(string text,string cap,int flags )
{
   int answ=MessageBox(text,cap, MB_YESNO);
   return(answ);
}   

void Object_field(string name, string text, int X, int Y, int size, string Srift,color CL1, color CL2,int Angle=0) {
   if (ObjectFind(name) == -1 ) ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
   ObjectSet(name, OBJPROP_COLOR, CL1);
   ObjectSet(name, OBJPROP_XDISTANCE, X);
   ObjectSet(name, OBJPROP_YDISTANCE, Y);
   if (Angle>0) ObjectSet(name, OBJPROP_ANGLE,Angle);
   ObjectSetText(name,text, size,Srift,CL2);
}
//+------------------------------------------------------------------+
//|     TRANSFER zero_point                                
//+------------------------------------------------------------------+
void reset_zp()
   {
   if (move_zp==true) 
     {
      zero_point= iTime(Symbol(),tf,0) ;
      GlobalVariableSet("zero_point",zero_point);
      RefreshRates();
      }
      return;
   }
//+------------------------------------------------------------------+
//|     MediaHighway server When lost communication                                
//+------------------------------------------------------------------+
void reconn()
{
     int hMetaTrader = GetAncestor(WindowHandle(Symbol(),Period()),2); //  focus on the terminal window
     if (hMetaTrader !=0) PostMessageA (hMetaTrader, WM_COMMAND, 37400, 0); // command rescan all servers
    return;
}   

// It's all, Folks!